# -*- coding: utf-8 -*-
"""ETL.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1R25crGhQRJrbTaYE6fByL3DVTvdB997G
"""

import psycopg2
import pandas as pd
import numpy as np

def ETL():

    conn = psycopg2.connect(
        host="localhost",
        database="postgres",
        user="postgres",
        password="ADSDB")
    cursor=conn.cursor()

    """# **Extracting data WORLD BANK**"""

    cursor.execute("SELECT * FROM public.world_data_bank_source20220123")
    data=cursor.fetchall()
    query="select c.column_name from information_schema.columns c where table_catalog='postgres' and table_schema='public' and table_name='world_data_bank_source20220123'"
    cursor.execute(query)
    def tu(tupla):
        return tupla[0]
    columns=cursor.fetchall()
    columns=list(map(tu,columns))

    df2=pd.DataFrame(data, columns=columns)

    """# **Extracting data Happiness report**"""

    cursor.execute("SELECT * FROM public.happiness_report_source20220123")
    data=cursor.fetchall()
    query="select c.column_name from information_schema.columns c where table_catalog='postgres' and table_schema='public' and table_name='happiness_report_source20220123'"
    cursor.execute(query)
    def tu(tupla):
        return tupla[0]
    columns=cursor.fetchall()
    columns=list(map(tu,columns))

    df1=pd.DataFrame(data, columns=columns)


    """# ***Data Integration***:
    Left Join between happiness and world_bank
    """

    df1['Year']=df1['Year'].astype(str)



    df = pd.merge(df1,df2, how='left', left_on=['Country Name','Year'], right_on = ['Country Name','Year'])
    df=df.dropna()

    df.to_csv('C:\Users\snadal\PycharmProjects\ADSDB\Explotation_zone\dataset.csv', index=False)

    tpls = [tuple(x) for x in df.to_numpy()]
    cols = '" ,"'.join(list(df.columns))
    cols='"'+cols+'"'
    for i in range(len(tpls)):
      query="INSERT INTO {0}({1}) VALUES ("
      query  = query.format("public.dataset20220123", cols)
      tupla=list(tpls[i])

      tupla[0]="'"+tupla[0]+"'"
      tupla[1]="'"+tupla[1]+"'"
      tupla=tuple(tupla)
      for index, v in enumerate(tupla) :
        if index==len(tupla)-1:
          break
        query=query+str(v)+', '
      query=query+str(tupla[len(tupla)-1])+')'
      cursor.execute(query)
      print(tupla[0]+" inserted")
    conn.commit()

    cursor.execute("ROLLBACK;")

